Subject: Re: bug#68246: 30.0.50; Add non-TS mode as extra parent of TS modes

From: Eli Zaretskii <[email-masked]>
Date: Mon, 15 Jan 2024 14:38:44 +0200

> From: João Távora <[email-masked]>
> Cc: [email-masked],  [email-masked],  [email-masked]
> Date: Sun, 14 Jan 2024 23:40:17 +0000
> 
> Eli Zaretskii <[email-masked]> writes:
> 
> >> However it is not easy to quantify confused users looking to understand
> >> the new meaning of things in dir-locals.el.  Or users wondering why they
> >> need to set Eglot variables in both 'c++-mode-hook' and
> >> 'c++-ts-mode-hook' when all they see is 'c++-mode' in
> >> 'eglot-server-programs'.
> >
> > Those users will hopefully submit bug reports or otherwise complain on
> > the Emacs mailing lists, and then we will know.
> 
> You also know this doesn't always happen.

It's our only reliable instrument of getting feedback for our
decisions.

> > The recommendation is to use base modes where it makes sense, and the
> > installed changes around derived-mode-add-parents don't in any way
> > preclude having a base mode and don't make it harder.  But I don't
> > think we should force everyone in this situation to invent a base mode
> > as the sole means for solving this.
> 
> We can invent for them.

Yes, but only where it makes sense.  For example, an empty base mode
doesn't.

> An empty base mode is useful just for its hook and its behaviour in
> dir-locals, for example.

No, it is completely useless, and we shouldn't introduce such modes.